/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: calculat.h /main/3 1995/11/08 10:07:11 rswiston $ */
/* this file contains special character expansions for various characters
 *    in Dot Matrix (computer), Menu Label (ml), and White Menu Label (wl)
 *    arrays are: ccompspec[] --> computer specials
 *                cmenlspec[] --> menu label specials
 *                cwmenlspec[]--> white menu label specials
 */

/* special computer expansions for dot matrix in calculator style */
EXTERN char *ccompspec[256] 
#if defined(DEFINE)
= {
/* Char Name                        TeX Expansion */
/*                                                */
/*   0: ^@  NUL                         */ 0,
/*   1: ^A  SOH                         */ 0,
/*   2: ^B  STX                         */ 0,
/*   3: ^C  ETX                         */ 0,
/*   4: ^D  EOT                         */ 0,
/*   5: ^E  ENQ                         */ 0,
/*   6: ^F  ACK                         */ 0,
/*   7: ^G  BEL                         */ 0,
/*   8: ^H  BS                          */ 0,
/*   9: ^I  HT                          */ 0,
/*  10: ^J  LF                          */ 0,
/*  11: ^K  VT                          */ 0,
/*  12: ^L  FF                          */ 0,
/*  13: ^M  CR                          */ 0,
/*  14: ^N  SO                          */ 0,
/*  15: ^O  SI                          */ 0,
/*  16: ^P  DLE                         */ 0,
/*  17: ^Q  DC1                         */ 0,
/*  18: ^R  DC2                         */ 0,
/*  19: ^S  DC3                         */ 0,
/*  20: ^T  DC4                         */ 0,
/*  21: ^U  NAK                         */ 0,
/*  22: ^V  SYN                         */ 0,
/*  23: ^W  ETB                         */ 0,
/*  24: ^X  CAN                         */ 0,
/*  25: ^Y  EM                          */ 0,
/*  26: ^Z  SUB                         */ 0,
/*  27: ^[  ESC                         */ 0,
/*  28: ^\  FS                          */ 0,
/*  29: ^]  GS                          */ 0,
/*  30: ^^  RS                          */ 0,
/*  31: ^_  US                          */ 0,
/*  32: SP                              */ 0,
/*  33: !                               */ 0,
/*  34: "                               */ 0,
/*  35: #                               */ "\\#",
/*  36: $                               */ "{\\dollar}",
/*  37: %                               */ "\\%",
/*  38: &                               */ "\\&",
/*  39: '                               */ "{'}",
/*  40: (                               */ 0,
/*  41: )                               */ 0,
/*  42: *                               */ 0,
/*  43: +                               */ 0,
/*  44: ,                               */ 0,
/*  45: -                               */ "{-}",
/*  46: .                               */ 0,
/*  47: /                               */ 0,
/*  48: 0                               */ 0,
/*  49: 1                               */ 0,
/*  50: 2                               */ 0,
/*  51: 3                               */ 0,
/*  52: 4                               */ 0,
/*  53: 5                               */ 0,
/*  54: 6                               */ 0,
/*  55: 7                               */ 0,
/*  56: 8                               */ 0,
/*  57: 9                               */ 0,
/*  58: :                               */ 0,
/*  59: ;                               */ 0,
/*  60: <                               */ "{\\tendmb\\char'045}",
/*  61: =                               */ 0,
/*  62: >                               */ "{\\tendmb\\char'046}",
/*  63: ?                               */ 0,
/*  64: @                               */ 0,
/*  65: A                               */ 0,
/*  66: B                               */ 0,
/*  67: C                               */ 0,
/*  68: D                               */ 0,
/*  69: E                               */ 0,
/*  70: F                               */ 0,
/*  71: G                               */ 0,
/*  72: H                               */ 0,
/*  73: I                               */ 0,
/*  74: J                               */ 0,
/*  75: K                               */ 0,
/*  76: L                               */ 0,
/*  77: M                               */ 0,
/*  78: N                               */ 0,
/*  79: O                               */ 0,
/*  80: P                               */ 0,
/*  81: Q                               */ 0,
/*  82: R                               */ 0,
/*  83: S                               */ 0,
/*  84: T                               */ 0,
/*  85: U                               */ 0,
/*  86: V                               */ 0,
/*  87: W                               */ 0,
/*  88: X                               */ 0,
/*  89: Y                               */ 0,
/*  90: Z                               */ 0,
/*  91: [                               */ 0,
/*  92: \\                              */ "{\\tendmb\\char'047}",
/*  93: ]                               */ 0,
/*  94: ^                               */ "{\\tendmb\\char'064}",
/*  95: _                               */ "{\\tendmb\\char'066}",
/*  96: `                               */ "{`}",
/*  97: a                               */ 0,
/*  98: b                               */ 0,
/*  99: c                               */ 0,
/* 100: d                               */ 0,
/* 101: e                               */ 0,
/* 102: f                               */ 0,
/* 103: g                               */ 0,
/* 104: h                               */ 0,
/* 105: i                               */ 0,
/* 106: j                               */ 0,
/* 107: k                               */ 0,
/* 108: l                               */ 0,
/* 109: m                               */ 0,
/* 110: n                               */ 0,
/* 111: o                               */ 0,
/* 112: p                               */ 0,
/* 113: q                               */ 0,
/* 114: r                               */ 0,
/* 115: s                               */ 0,
/* 116: t                               */ 0,
/* 117: u                               */ 0,
/* 118: v                               */ 0,
/* 119: w                               */ 0,
/* 120: x                               */ 0,
/* 121: y                               */ 0,
/* 122: z                               */ 0,
/* 123: {                               */ "{\\tendmb\\char'070}",
/* 124: |                               */ "{\\tendmb\\char'104}",
/* 125: }                               */ "{\\tendmb\\char'107}",
/* 126: ~                               */ "{\\tendmb\\char'116}",
/* 127: DEL                             */ 0,
/* 128: undefined                       */ 0,
/* 129: undefined                       */ 0,
/* 130: undefined                       */ 0,
/* 131: undefined                       */ 0,
/* 132: undefined                       */ 0,
/* 133: undefined                       */ 0,
/* 134: undefined                       */ 0,
/* 135: undefined                       */ 0,
/* 136: undefined                       */ 0,
/* 137: undefined                       */ 0,
/* 138: undefined                       */ 0,
/* 139: undefined                       */ 0,
/* 140: undefined                       */ 0,
/* 141: undefined                       */ 0,
/* 142: undefined                       */ 0,
/* 143: undefined                       */ 0,
/* 144: undefined                       */ 0,
/* 145: undefined                       */ 0,
/* 146: undefined                       */ 0,
/* 147: undefined                       */ 0,
/* 148: undefined                       */ 0,
/* 149: undefined                       */ 0,
/* 150: undefined                       */ 0,
/* 151: undefined                       */ 0,
/* 152: undefined                       */ 0,
/* 153: undefined                       */ 0,
/* 154: undefined                       */ 0,
/* 155: undefined                       */ 0,
/* 156: undefined                       */ 0,
/* 157: undefined                       */ 0,
/* 158: undefined                       */ 0,
/* 159: undefined                       */ 0,
/* 160: undefined                       */ 0,
/* 161: A   grave                       */ "{\\tendmc\\char'041}",
/* 162: A   circumflex                  */ "{\\tendmc\\char'042}",
/* 163: E   grave                       */ "{\\tendmc\\char'043}",
/* 164: E   circumflex                  */ "{\\tendmc\\char'044}",
/* 165: E   dieresis                    */ "{\\tendmc\\char'045}",
/* 166: I   circumflex                  */ "{\\tendmc\\char'046}",
/* 167: I   dieresis                    */ "{\\tendmc\\char'047}",
/* 168: acute accent                    */ "{\\tendma\\char'023}",
/* 169: grave accent                    */ "{\\tendma\\char'022}",
/* 170: circumflex                      */ "{\\tendma\\char'136}",
/* 171: dieresis                        */ "{\\tendma\\char'177}",
/* 172: tilde                           */ "{\\tendma\\char'176}",
/* 173: U   grave                       */ "{\\tendmc\\char'050}",
/* 174: U   circumflex                  */ "{\\tendmc\\char'051}",
/* 175: Italian Lira                    */ 0,
/* 176: overbar                         */ 0,
/* 177: Y   acute                       */ "{\\tendmc\\char'053}",
/* 178: y   acute                       */ "{\\tendmc\\char'054}",
/* 179: degree                          */ 0,
/* 180: C   cedilla                     */ "{\\tendma\\char'030}",
/* 181: c   cedilla                     */ "{\\tendma\\char'030}",
/* 182: N   tilde                       */ "{\\tendmc\\char'055}",
/* 183: n   tilde                       */ "{\\tendmc\\char'056}",
/* 184: inverted exclamation mark       */ "{\\tendma\\char'074}",
/* 185: inverted question mark          */ "{\\tendma\\char'076}",
/* 186: currency sign                   */ 0,
/* 187: pound sterling                  */ 0,
/* 188: Yen                             */ 0,
/* 189: Section sign                    */ 0,
/* 190: florin                          */ 0,
/* 191: Cent sign                       */ 0,
/* 192: a   circumflex                  */ "{\\tendmc\\char'063}",
/* 193: e   circumflex                  */ "{\\tendmc\\char'064}",
/* 194: o   circumflex                  */ "{\\tendmc\\char'065}",
/* 195: u   circumflex                  */ "{\\tendmc\\char'066}",
/* 196: a   acute                       */ "{\\tendmc\\char'067}",
/* 197: e   acute                       */ "{\\tendmc\\char'070}",
/* 198: o   acute                       */ "{\\tendmc\\char'071}",
/* 199: u   acute                       */ "{\\tendmc\\char'072}",
/* 200: a   grave                       */ "{\\tendmc\\char'073}",
/* 201: e   grave                       */ "{\\tendmc\\char'074}",
/* 202: o   grave                       */ "{\\tendmc\\char'075}",
/* 203: u   grave                       */ "{\\tendmc\\char'076}",
/* 204: a   dieresis                    */ "{\\tendmc\\char'077}",
/* 205: e   dieresis                    */ "{\\tendmc\\char'100}",
/* 206: o   dieresis                    */ "{\\tendmc\\char'101}",
/* 207: u   dieresis                    */ "{\\tendmc\\char'102}",
/* 208: A   angstrom                    */ "{\\tendmc\\char'103}",
/* 209: i   circumflex                  */ "{\\tendmc\\char'104}",
/* 210: O   slash                       */ "{\\tendma\\char'037}",
/* 211: AE  ligature                    */ "{\\tendma\\char'035}",
/* 212: a   angstrom                    */ "{\\tendmc\\char'105}",
/* 213: i   acute                       */ "{\\tendmc\\char'106}",
/* 214: o   slash                       */ "{\\tendma\\char'034}",
/* 215: ae  ligature                    */ "{\\tendma\\char'032}",
/* 216: A   dieresis                    */ "{\\tendmc\\char'107}",
/* 217: i   grave                       */ "{\\tendmc\\char'110}",
/* 218: O   dieresis                    */ "{\\tendmc\\char'111}",
/* 219: U   dieresis                    */ "{\\tendmc\\char'112}",
/* 220: E   acute                       */ "{\\tendmc\\char'113}",
/* 221: i   dieresis                    */ "{\\tendmc\\char'114}",
/* 222: SS  ligature                    */ "{\\tendma\\char'031}",
/* 223: O   circumflex                  */ "{\\tendmc\\char'115}",
/* 224: A   acute                       */ "{\\tendmc\\char'116}",
/* 225: A   tilde                       */ "{\\tendmc\\char'117}",
/* 226: a   tilde                       */ "{\\tendmc\\char'120}",
/* 227: Eth                             */ 0,
/* 228: eth                             */ 0,
/* 229: I   acute                       */ "{\\tendmc\\char'121}",
/* 230: I   grave                       */ "{\\tendmc\\char'122}",
/* 231: O   acute                       */ "{\\tendmc\\char'123}",
/* 232: O   grave                       */ "{\\tendmc\\char'124}",
/* 233: O   tilde                       */ "{\\tendmc\\char'125}",
/* 234: o   tilde                       */ "{\\tendmc\\char'126}",
/* 235: S   caron                       */ "{\\tendmc\\char'127}",
/* 236: s   caron                       */ "{\\tendmc\\char'130}",
/* 237: U   acute                       */ "{\\tendmc\\char'131}",
/* 238: Y   dieresis                    */ "{\\tendmc\\char'132}",
/* 239: y   dieresis                    */ "{\\tendmc\\char'133}",
/* 240: Thorn                           */ 0,
/* 241: thorn                           */ 0,
/* 242: undefined                       */ 0,
/* 243: mu                              */ 0,
/* 244: paragraph sign                  */ 0,
/* 245: fraction 3/4                    */ 0,
/* 246: long dash                       */ 0,
/* 247: fraction 1/4                    */ 0,
/* 248: fraction 1/2                    */ 0,
/* 249: Female ordinal                  */ 0,
/* 250: Male ordinal                    */ 0,
/* 251: French double open quote        */ 0,
/* 252: Solid square                    */ 0,
/* 253: French double close quote       */ 0,
/* 254: Plus over minus sign            */ 0,
/* 255: undefined                       */ 0
}
#endif
;

/* special menu label character expansions */
EXTERN char *cmenlspec[256] 
#if defined(DEFINE)
= {
/* Char Name                        TeX Expansion */
/*                                                */
/*   0: ^@  NUL                         */ 0,
/*   1: ^A  SOH                         */ 0,
/*   2: ^B  STX                         */ 0,
/*   3: ^C  ETX                         */ 0,
/*   4: ^D  EOT                         */ 0,
/*   5: ^E  ENQ                         */ 0,
/*   6: ^F  ACK                         */ 0,
/*   7: ^G  BEL                         */ 0,
/*   8: ^H  BS                          */ 0,
/*   9: ^I  HT                          */ 0,
/*  10: ^J  LF                          */ 0,
/*  11: ^K  VT                          */ 0,
/*  12: ^L  FF                          */ 0,
/*  13: ^M  CR                          */ 0,
/*  14: ^N  SO                          */ 0,
/*  15: ^O  SI                          */ 0,
/*  16: ^P  DLE                         */ 0,
/*  17: ^Q  DC1                         */ 0,
/*  18: ^R  DC2                         */ 0,
/*  19: ^S  DC3                         */ 0,
/*  20: ^T  DC4                         */ 0,
/*  21: ^U  NAK                         */ 0,
/*  22: ^V  SYN                         */ 0,
/*  23: ^W  ETB                         */ 0,
/*  24: ^X  CAN                         */ 0,
/*  25: ^Y  EM                          */ 0,
/*  26: ^Z  SUB                         */ 0,
/*  27: ^[  ESC                         */ 0,
/*  28: ^\  FS                          */ 0,
/*  29: ^]  GS                          */ 0,
/*  30: ^^  RS                          */ 0,
/*  31: ^_  US                          */ 0,
/*  32: SP                              */ "{\\tenmlb\\char'146}",
/*  33: !                               */ 0,
/*  34: "                               */ 0,
/*  35: #                               */ "\\#",
/*  36: $                               */ "{\\dollar}",
/*  37: %                               */ "\\%",
/*  38: &                               */ "\\&",
/*  39: '                               */ "{'}",
/*  40: (                               */ 0,
/*  41: )                               */ 0,
/*  42: *                               */ 0,
/*  43: +                               */ 0,
/*  44: ,                               */ 0,
/*  45: -                               */ "{-}",
/*  46: .                               */ 0,
/*  47: /                               */ 0,
/*  48: 0                               */ 0,
/*  49: 1                               */ 0,
/*  50: 2                               */ 0,
/*  51: 3                               */ 0,
/*  52: 4                               */ 0,
/*  53: 5                               */ 0,
/*  54: 6                               */ 0,
/*  55: 7                               */ 0,
/*  56: 8                               */ 0,
/*  57: 9                               */ 0,
/*  58: :                               */ 0,
/*  59: ;                               */ 0,
/*  60: <                               */ "{\\tenmlb\\char'045}",
/*  61: =                               */ 0,
/*  62: >                               */ "{\\tenmlb\\char'046}",
/*  63: ?                               */ 0,
/*  64: @                               */ 0,
/*  65: A                               */ 0,
/*  66: B                               */ 0,
/*  67: C                               */ 0,
/*  68: D                               */ 0,
/*  69: E                               */ 0,
/*  70: F                               */ 0,
/*  71: G                               */ 0,
/*  72: H                               */ 0,
/*  73: I                               */ 0,
/*  74: J                               */ 0,
/*  75: K                               */ 0,
/*  76: L                               */ 0,
/*  77: M                               */ 0,
/*  78: N                               */ 0,
/*  79: O                               */ 0,
/*  80: P                               */ 0,
/*  81: Q                               */ 0,
/*  82: R                               */ 0,
/*  83: S                               */ 0,
/*  84: T                               */ 0,
/*  85: U                               */ 0,
/*  86: V                               */ 0,
/*  87: W                               */ 0,
/*  88: X                               */ 0,
/*  89: Y                               */ 0,
/*  90: Z                               */ 0,
/*  91: [                               */ 0,
/*  92: \\                              */ "{\\tenmlb\\char'047}",
/*  93: ]                               */ 0,
/*  94: ^                               */ "{\\tenmlb\\char'064}",
/*  95: _                               */ "{\\tenmlb\\char'066}",
/*  96: `                               */ "{`}",
/*  97: a                               */ 0,
/*  98: b                               */ 0,
/*  99: c                               */ 0,
/* 100: d                               */ 0,
/* 101: e                               */ 0,
/* 102: f                               */ 0,
/* 103: g                               */ 0,
/* 104: h                               */ 0,
/* 105: i                               */ 0,
/* 106: j                               */ 0,
/* 107: k                               */ 0,
/* 108: l                               */ 0,
/* 109: m                               */ 0,
/* 110: n                               */ 0,
/* 111: o                               */ 0,
/* 112: p                               */ 0,
/* 113: q                               */ 0,
/* 114: r                               */ 0,
/* 115: s                               */ 0,
/* 116: t                               */ 0,
/* 117: u                               */ 0,
/* 118: v                               */ 0,
/* 119: w                               */ 0,
/* 120: x                               */ 0,
/* 121: y                               */ 0,
/* 122: z                               */ 0,
/* 123: {                               */ "{\\tenmlb\\char'070}",
/* 124: |                               */ "{\\tenmlb\\char'104}",
/* 125: }                               */ "{\\tenmlb\\char'107}",
/* 126: ~                               */ "{\\tenmlb\\char'116}",
/* 127: DEL                             */ 0,
/* 128: undefined                       */ 0,
/* 129: undefined                       */ 0,
/* 130: undefined                       */ 0,
/* 131: undefined                       */ 0,
/* 132: undefined                       */ 0,
/* 133: undefined                       */ 0,
/* 134: undefined                       */ 0,
/* 135: undefined                       */ 0,
/* 136: undefined                       */ 0,
/* 137: undefined                       */ 0,
/* 138: undefined                       */ 0,
/* 139: undefined                       */ 0,
/* 140: undefined                       */ 0,
/* 141: undefined                       */ 0,
/* 142: undefined                       */ 0,
/* 143: undefined                       */ 0,
/* 144: undefined                       */ 0,
/* 145: undefined                       */ 0,
/* 146: undefined                       */ 0,
/* 147: undefined                       */ 0,
/* 148: undefined                       */ 0,
/* 149: undefined                       */ 0,
/* 150: undefined                       */ 0,
/* 151: undefined                       */ 0,
/* 152: undefined                       */ 0,
/* 153: undefined                       */ 0,
/* 154: undefined                       */ 0,
/* 155: undefined                       */ 0,
/* 156: undefined                       */ 0,
/* 157: undefined                       */ 0,
/* 158: undefined                       */ 0,
/* 159: undefined                       */ 0,
/* 160: undefined                       */ 0,
/* 161: A   grave                       */ "{\\tenmlc\\char'041}",
/* 162: A   circumflex                  */ "{\\tenmlc\\char'042}",
/* 163: E   grave                       */ "{\\tenmlc\\char'043}",
/* 164: E   circumflex                  */ "{\\tenmlc\\char'044}",
/* 165: E   dieresis                    */ "{\\tenmlc\\char'045}",
/* 166: I   circumflex                  */ "{\\tenmlc\\char'046}",
/* 167: I   dieresis                    */ "{\\tenmlc\\char'047}",
/* 168: acute accent                    */ "{\\tenmla\\char'023}",
/* 169: grave accent                    */ "{\\tenmla\\char'022}",
/* 170: circumflex                      */ "{\\tenmla\\char'136}",
/* 171: dieresis                        */ "{\\tenmla\\char'177}",
/* 172: tilde                           */ "{\\tenmla\\char'176}",
/* 173: U   grave                       */ "{\\tenmlc\\char'050}",
/* 174: U   circumflex                  */ "{\\tenmlc\\char'051}",
/* 175: Italian Lira                    */ 0,
/* 176: overbar                         */ 0,
/* 177: Y   acute                       */ "{\\tenmlc\\char'053}",
/* 178: y   acute                       */ "{\\tenmlc\\char'054}",
/* 179: degree                          */ 0,
/* 180: C   cedilla                     */ "{\\tenmla\\char'030}",
/* 181: c   cedilla                     */ "{\\tenmla\\char'030}",
/* 182: N   tilde                       */ "{\\tenmlc\\char'055}",
/* 183: n   tilde                       */ "{\\tenmlc\\char'056}",
/* 184: inverted exclamation mark       */ "{\\tenmla\\char'074}",
/* 185: inverted question mark          */ "{\\tenmla\\char'076}",
/* 186: currency sign                   */ 0,
/* 187: pound sterling                  */ 0,
/* 188: Yen                             */ 0,
/* 189: Section sign                    */ 0,
/* 190: florin                          */ 0,
/* 191: Cent sign                       */ 0,
/* 192: a   circumflex                  */ "{\\tenmlc\\char'063}",
/* 193: e   circumflex                  */ "{\\tenmlc\\char'064}",
/* 194: o   circumflex                  */ "{\\tenmlc\\char'065}",
/* 195: u   circumflex                  */ "{\\tenmlc\\char'066}",
/* 196: a   acute                       */ "{\\tenmlc\\char'067}",
/* 197: e   acute                       */ "{\\tenmlc\\char'070}",
/* 198: o   acute                       */ "{\\tenmlc\\char'071}",
/* 199: u   acute                       */ "{\\tenmlc\\char'072}",
/* 200: a   grave                       */ "{\\tenmlc\\char'073}",
/* 201: e   grave                       */ "{\\tenmlc\\char'074}",
/* 202: o   grave                       */ "{\\tenmlc\\char'075}",
/* 203: u   grave                       */ "{\\tenmlc\\char'076}",
/* 204: a   dieresis                    */ "{\\tenmlc\\char'077}",
/* 205: e   dieresis                    */ "{\\tenmlc\\char'100}",
/* 206: o   dieresis                    */ "{\\tenmlc\\char'101}",
/* 207: u   dieresis                    */ "{\\tenmlc\\char'102}",
/* 208: A   angstrom                    */ "{\\tenmlc\\char'103}",
/* 209: i   circumflex                  */ "{\\tenmlc\\char'104}",
/* 210: O   slash                       */ "{\\tenmla\\char'037}",
/* 211: AE  ligature                    */ "{\\tenmla\\char'035}",
/* 212: a   angstrom                    */ "{\\tenmlc\\char'105}",
/* 213: i   acute                       */ "{\\tenmlc\\char'106}",
/* 214: o   slash                       */ "{\\tenmla\\char'034}",
/* 215: ae  ligature                    */ "{\\tenmla\\char'032}",
/* 216: A   dieresis                    */ "{\\tenmlc\\char'107}",
/* 217: i   grave                       */ "{\\tenmlc\\char'110}",
/* 218: O   dieresis                    */ "{\\tenmlc\\char'111}",
/* 219: U   dieresis                    */ "{\\tenmlc\\char'112}",
/* 220: E   acute                       */ "{\\tenmlc\\char'113}",
/* 221: i   dieresis                    */ "{\\tenmlc\\char'114}",
/* 222: SS  ligature                    */ "{\\tenmla\\char'031}",
/* 223: O   circumflex                  */ "{\\tenmlc\\char'115}",
/* 224: A   acute                       */ "{\\tenmlc\\char'116}",
/* 225: A   tilde                       */ "{\\tenmlc\\char'117}",
/* 226: a   tilde                       */ "{\\tenmlc\\char'120}",
/* 227: Eth                             */ 0,
/* 228: eth                             */ 0,
/* 229: I   acute                       */ "{\\tenmlc\\char'121}",
/* 230: I   grave                       */ "{\\tenmlc\\char'122}",
/* 231: O   acute                       */ "{\\tenmlc\\char'123}",
/* 232: O   grave                       */ "{\\tenmlc\\char'124}",
/* 233: O   tilde                       */ "{\\tenmlc\\char'125}",
/* 234: o   tilde                       */ "{\\tenmlc\\char'126}",
/* 235: S   caron                       */ "{\\tenmlc\\char'127}",
/* 236: s   caron                       */ "{\\tenmlc\\char'130}",
/* 237: U   acute                       */ "{\\tenmlc\\char'131}",
/* 238: Y   dieresis                    */ "{\\tenmlc\\char'132}",
/* 239: y   dieresis                    */ "{\\tenmlc\\char'133}",
/* 240: Thorn                           */ 0,
/* 241: thorn                           */ 0,
/* 242: undefined                       */ 0,
/* 243: mu                              */ 0,
/* 244: paragraph sign                  */ 0,
/* 245: fraction 3/4                    */ 0,
/* 246: long dash                       */ 0,
/* 247: fraction 1/4                    */ 0,
/* 248: fraction 1/2                    */ 0,
/* 249: Female ordinal                  */ 0,
/* 250: Male ordinal                    */ 0,
/* 251: French double open quote        */ 0,
/* 252: Solid square                    */ 0,
/* 253: French double close quote       */ 0,
/* 254: Plus over minus sign            */ 0,
/* 255: undefined                       */ 0
}
#endif
;

/* white menu label special character expansions */
EXTERN char *cwmenlspec[256] 
#if defined(DEFINE)
= {
/* Char Name                        TeX Expansion */
/*                                                */
/*   0: ^@  NUL                         */ 0,
/*   1: ^A  SOH                         */ 0,
/*   2: ^B  STX                         */ 0,
/*   3: ^C  ETX                         */ 0,
/*   4: ^D  EOT                         */ 0,
/*   5: ^E  ENQ                         */ 0,
/*   6: ^F  ACK                         */ 0,
/*   7: ^G  BEL                         */ 0,
/*   8: ^H  BS                          */ 0,
/*   9: ^I  HT                          */ 0,
/*  10: ^J  LF                          */ 0,
/*  11: ^K  VT                          */ 0,
/*  12: ^L  FF                          */ 0,
/*  13: ^M  CR                          */ 0,
/*  14: ^N  SO                          */ 0,
/*  15: ^O  SI                          */ 0,
/*  16: ^P  DLE                         */ 0,
/*  17: ^Q  DC1                         */ 0,
/*  18: ^R  DC2                         */ 0,
/*  19: ^S  DC3                         */ 0,
/*  20: ^T  DC4                         */ 0,
/*  21: ^U  NAK                         */ 0,
/*  22: ^V  SYN                         */ 0,
/*  23: ^W  ETB                         */ 0,
/*  24: ^X  CAN                         */ 0,
/*  25: ^Y  EM                          */ 0,
/*  26: ^Z  SUB                         */ 0,
/*  27: ^[  ESC                         */ 0,
/*  28: ^\  FS                          */ 0,
/*  29: ^]  GS                          */ 0,
/*  30: ^^  RS                          */ 0,
/*  31: ^_  US                          */ 0,
/*  32: SP                              */ "{\\tenwlb\\char'146}",
/*  33: !                               */ 0,
/*  34: "                               */ 0,
/*  35: #                               */ "\\#",
/*  36: $                               */ "{\\dollar}",
/*  37: %                               */ "\\%",
/*  38: &                               */ "\\&",
/*  39: '                               */ "{'}",
/*  40: (                               */ 0,
/*  41: )                               */ 0,
/*  42: *                               */ 0,
/*  43: +                               */ 0,
/*  44: ,                               */ 0,
/*  45: -                               */ "{-}",
/*  46: .                               */ 0,
/*  47: /                               */ 0,
/*  48: 0                               */ 0,
/*  49: 1                               */ 0,
/*  50: 2                               */ 0,
/*  51: 3                               */ 0,
/*  52: 4                               */ 0,
/*  53: 5                               */ 0,
/*  54: 6                               */ 0,
/*  55: 7                               */ 0,
/*  56: 8                               */ 0,
/*  57: 9                               */ 0,
/*  58: :                               */ 0,
/*  59: ;                               */ 0,
/*  60: <                               */ "{\\tenwlb\\char'045}",
/*  61: =                               */ 0,
/*  62: >                               */ "{\\tenwlb\\char'046}",
/*  63: ?                               */ 0,
/*  64: @                               */ 0,
/*  65: A                               */ 0,
/*  66: B                               */ 0,
/*  67: C                               */ 0,
/*  68: D                               */ 0,
/*  69: E                               */ 0,
/*  70: F                               */ 0,
/*  71: G                               */ 0,
/*  72: H                               */ 0,
/*  73: I                               */ 0,
/*  74: J                               */ 0,
/*  75: K                               */ 0,
/*  76: L                               */ 0,
/*  77: M                               */ 0,
/*  78: N                               */ 0,
/*  79: O                               */ 0,
/*  80: P                               */ 0,
/*  81: Q                               */ 0,
/*  82: R                               */ 0,
/*  83: S                               */ 0,
/*  84: T                               */ 0,
/*  85: U                               */ 0,
/*  86: V                               */ 0,
/*  87: W                               */ 0,
/*  88: X                               */ 0,
/*  89: Y                               */ 0,
/*  90: Z                               */ 0,
/*  91: [                               */ 0,
/*  92: \\                              */ "{\\tenwlb\\char'047}",
/*  93: ]                               */ 0,
/*  94: ^                               */ "{\\tenwlb\\char'064}",
/*  95: _                               */ "{\\tenwlb\\char'066}",
/*  96: `                               */ "{`}",
/*  97: a                               */ 0,
/*  98: b                               */ 0,
/*  99: c                               */ 0,
/* 100: d                               */ 0,
/* 101: e                               */ 0,
/* 102: f                               */ 0,
/* 103: g                               */ 0,
/* 104: h                               */ 0,
/* 105: i                               */ 0,
/* 106: j                               */ 0,
/* 107: k                               */ 0,
/* 108: l                               */ 0,
/* 109: m                               */ 0,
/* 110: n                               */ 0,
/* 111: o                               */ 0,
/* 112: p                               */ 0,
/* 113: q                               */ 0,
/* 114: r                               */ 0,
/* 115: s                               */ 0,
/* 116: t                               */ 0,
/* 117: u                               */ 0,
/* 118: v                               */ 0,
/* 119: w                               */ 0,
/* 120: x                               */ 0,
/* 121: y                               */ 0,
/* 122: z                               */ 0,
/* 123: {                               */ "{\\tenwlb\\char'070}",
/* 124: |                               */ "{\\tenwlb\\char'104}",
/* 125: }                               */ "{\\tenwlb\\char'107}",
/* 126: ~                               */ "{\\tenwlb\\char'116}",
/* 127: DEL                             */ 0,
/* 128: undefined                       */ 0,
/* 129: undefined                       */ 0,
/* 130: undefined                       */ 0,
/* 131: undefined                       */ 0,
/* 132: undefined                       */ 0,
/* 133: undefined                       */ 0,
/* 134: undefined                       */ 0,
/* 135: undefined                       */ 0,
/* 136: undefined                       */ 0,
/* 137: undefined                       */ 0,
/* 138: undefined                       */ 0,
/* 139: undefined                       */ 0,
/* 140: undefined                       */ 0,
/* 141: undefined                       */ 0,
/* 142: undefined                       */ 0,
/* 143: undefined                       */ 0,
/* 144: undefined                       */ 0,
/* 145: undefined                       */ 0,
/* 146: undefined                       */ 0,
/* 147: undefined                       */ 0,
/* 148: undefined                       */ 0,
/* 149: undefined                       */ 0,
/* 150: undefined                       */ 0,
/* 151: undefined                       */ 0,
/* 152: undefined                       */ 0,
/* 153: undefined                       */ 0,
/* 154: undefined                       */ 0,
/* 155: undefined                       */ 0,
/* 156: undefined                       */ 0,
/* 157: undefined                       */ 0,
/* 158: undefined                       */ 0,
/* 159: undefined                       */ 0,
/* 160: undefined                       */ 0,
/* 161: A   grave                       */ "{\\tenwlc\\char'041}",
/* 162: A   circumflex                  */ "{\\tenwlc\\char'042}",
/* 163: E   grave                       */ "{\\tenwlc\\char'043}",
/* 164: E   circumflex                  */ "{\\tenwlc\\char'044}",
/* 165: E   dieresis                    */ "{\\tenwlc\\char'045}",
/* 166: I   circumflex                  */ "{\\tenwlc\\char'046}",
/* 167: I   dieresis                    */ "{\\tenwlc\\char'047}",
/* 168: acute accent                    */ "{\\tenwla\\char'023}",
/* 169: grave accent                    */ "{\\tenwla\\char'022}",
/* 170: circumflex                      */ "{\\tenwla\\char'136}",
/* 171: dieresis                        */ "{\\tenwla\\char'177}",
/* 172: tilde                           */ "{\\tenwla\\char'176}",
/* 173: U   grave                       */ "{\\tenwlc\\char'050}",
/* 174: U   circumflex                  */ "{\\tenwlc\\char'051}",
/* 175: Italian Lira                    */ 0,
/* 176: overbar                         */ 0,
/* 177: Y   acute                       */ "{\\tenwlc\\char'053}",
/* 178: y   acute                       */ "{\\tenwlc\\char'054}",
/* 179: degree                          */ 0,
/* 180: C   cedilla                     */ "{\\tenwla\\char'030}",
/* 181: c   cedilla                     */ "{\\tenwla\\char'030}",
/* 182: N   tilde                       */ "{\\tenwlc\\char'055}",
/* 183: n   tilde                       */ "{\\tenwlc\\char'056}",
/* 184: inverted exclamation mark       */ "{\\tenwla\\char'074}",
/* 185: inverted question mark          */ "{\\tenwla\\char'076}",
/* 186: currency sign                   */ 0,
/* 187: pound sterling                  */ 0,
/* 188: Yen                             */ 0,
/* 189: Section sign                    */ 0,
/* 190: florin                          */ 0,
/* 191: Cent sign                       */ 0,
/* 192: a   circumflex                  */ "{\\tenwlc\\char'063}",
/* 193: e   circumflex                  */ "{\\tenwlc\\char'064}",
/* 194: o   circumflex                  */ "{\\tenwlc\\char'065}",
/* 195: u   circumflex                  */ "{\\tenwlc\\char'066}",
/* 196: a   acute                       */ "{\\tenwlc\\char'067}",
/* 197: e   acute                       */ "{\\tenwlc\\char'070}",
/* 198: o   acute                       */ "{\\tenwlc\\char'071}",
/* 199: u   acute                       */ "{\\tenwlc\\char'072}",
/* 200: a   grave                       */ "{\\tenwlc\\char'073}",
/* 201: e   grave                       */ "{\\tenwlc\\char'074}",
/* 202: o   grave                       */ "{\\tenwlc\\char'075}",
/* 203: u   grave                       */ "{\\tenwlc\\char'076}",
/* 204: a   dieresis                    */ "{\\tenwlc\\char'077}",
/* 205: e   dieresis                    */ "{\\tenwlc\\char'100}",
/* 206: o   dieresis                    */ "{\\tenwlc\\char'101}",
/* 207: u   dieresis                    */ "{\\tenwlc\\char'102}",
/* 208: A   angstrom                    */ "{\\tenwlc\\char'103}",
/* 209: i   circumflex                  */ "{\\tenwlc\\char'104}",
/* 210: O   slash                       */ "{\\tenwla\\char'037}",
/* 211: AE  ligature                    */ "{\\tenwla\\char'035}",
/* 212: a   angstrom                    */ "{\\tenwlc\\char'105}",
/* 213: i   acute                       */ "{\\tenwlc\\char'106}",
/* 214: o   slash                       */ "{\\tenwla\\char'034}",
/* 215: ae  ligature                    */ "{\\tenwla\\char'032}",
/* 216: A   dieresis                    */ "{\\tenwlc\\char'107}",
/* 217: i   grave                       */ "{\\tenwlc\\char'110}",
/* 218: O   dieresis                    */ "{\\tenwlc\\char'111}",
/* 219: U   dieresis                    */ "{\\tenwlc\\char'112}",
/* 220: E   acute                       */ "{\\tenwlc\\char'113}",
/* 221: i   dieresis                    */ "{\\tenwlc\\char'114}",
/* 222: SS  ligature                    */ "{\\tenwla\\char'031}",
/* 223: O   circumflex                  */ "{\\tenwlc\\char'115}",
/* 224: A   acute                       */ "{\\tenwlc\\char'116}",
/* 225: A   tilde                       */ "{\\tenwlc\\char'117}",
/* 226: a   tilde                       */ "{\\tenwlc\\char'120}",
/* 227: Eth                             */ 0,
/* 228: eth                             */ 0,
/* 229: I   acute                       */ "{\\tenwlc\\char'121}",
/* 230: I   grave                       */ "{\\tenwlc\\char'122}",
/* 231: O   acute                       */ "{\\tenwlc\\char'123}",
/* 232: O   grave                       */ "{\\tenwlc\\char'124}",
/* 233: O   tilde                       */ "{\\tenwlc\\char'125}",
/* 234: o   tilde                       */ "{\\tenwlc\\char'126}",
/* 235: S   caron                       */ "{\\tenwlc\\char'127}",
/* 236: s   caron                       */ "{\\tenwlc\\char'130}",
/* 237: U   acute                       */ "{\\tenwlc\\char'131}",
/* 238: Y   dieresis                    */ "{\\tenwlc\\char'132}",
/* 239: y   dieresis                    */ "{\\tenwlc\\char'133}",
/* 240: Thorn                           */ 0,
/* 241: thorn                           */ 0,
/* 242: undefined                       */ 0,
/* 243: mu                              */ 0,
/* 244: paragraph sign                  */ 0,
/* 245: fraction 3/4                    */ 0,
/* 246: long dash                       */ 0,
/* 247: fraction 1/4                    */ 0,
/* 248: fraction 1/2                    */ 0,
/* 249: Female ordinal                  */ 0,
/* 250: Male ordinal                    */ 0,
/* 251: French double open quote        */ 0,
/* 252: Solid square                    */ 0,
/* 253: French double close quote       */ 0,
/* 254: Plus over minus sign            */ 0,
/* 255: undefined                       */ 0
}
#endif
;

