/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: align.c /main/3 1995/11/01 17:25:09 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*          Copyright (c) 1994 AT&T Bell Laboratories           *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Software Engineering Research Department           *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                   advsoft@research.att.com                   *
*                 Randy Hackbarth 908-582-5245                 *
*                  Dave Belanger 908-582-7427                  *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#line 1

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif

#line 11
union _u_
{
	long		u1;
	char*		u2;
	double		u3;
	char		u4[1024];
};

struct _s_
{
	char		s1;
	union _u_	s2;
};

#define roundof(x,y)	(((x)+((y)-1))&~((y)-1))

extern __MANGLE__ int		printf __PROTO__((const char*, ...));

int main()
{
	int	i;
	int	j;
	int	k;

	int		align0;
	int		align1;
	int		align2;
	unsigned long	bit1;
	unsigned long	bit2;
	unsigned long	bits0;
	unsigned long	bits1;
	unsigned long	bits2;
	union _u_	u;
	union _u_	v;

	u.u2 = u.u4;
	v.u2 = u.u2 + 1;
	bit1 = u.u1 ^ v.u1;
	v.u2 = u.u2 + 2;
	bit2 = u.u1 ^ v.u1;
	align0 = sizeof(struct _s_) - sizeof(union _u_);
	bits0 = 0;
	k = 0;
	for (j = 0; j < align0; j++)
	{
		u.u2 = u.u4 + j;
		bits1 = 0;
		for (i = 0; i < align0; i++)
		{
			v.u2 = u.u2 + i;
			bits1 |= u.u1 ^ v.u1;
		}
		if (!bits0 || bits1 < bits0)
		{
			bits0 = bits1;
			k = j;
		}
	}
	align1 = roundof(align0, 2);
	u.u2 = u.u4 + k;
	for (bits1 = bits0; i < align1; i++)
	{
		v.u2 = u.u2 + i;
		bits1 |= u.u1 ^ v.u1;
	}
	align2 = roundof(align0, 4);
	for (bits2 = bits1; i < align2; i++)
	{
		v.u2 = u.u2 + i;
		bits2 |= u.u1 ^ v.u1;
	}
	printf("typedef unsigned %s INTEGRAL;\n", sizeof(char*) >= sizeof(long) ? "long" : sizeof(char*) >= sizeof(int) ? "int" : "short");
	printf("\n");
	printf("#define CHUNK		%d\n", sizeof(char*) >= 4 ? 8192 : 1024);
	printf("#define INTEGRAL	%s\n", sizeof(char*) >= sizeof(long) ? "long" : sizeof(char*) >= sizeof(int) ? "int" : "short");
	printf("#define INTEGER(x)	((INTEGRAL)(x))\n");
	printf("#define POINTER(x)	((char*)(x))\n");
	if (bits2 == (align2 - 1)) printf("#define ROUND(x,y)	POINTER(INTEGER((x)+(y)-1)&~((y)-1))\n");
	else printf("#define ROUND(x,y)	POINTER(INTEGER(ALIGN(x)+(((y)+%d)/%d)-1)&~((((y)+%d)/%d)-1))\n", align0, align0, align0, align0);
	printf("\n");
	if (align0 == align2)
	{
		printf("#define BOUND		BOUND2\n");
		printf("#define ALIGN(x)	ALIGN2(x)\n");
		printf("#define TRUNC(x)	TRUNC2(x)\n");
	}
	else if (align0 == align1)
	{
		printf("#define BOUND		BOUND1\n");
		printf("#define ALIGN(x)	ALIGN1(x)\n");
		printf("#define TRUNC(x)	TRUNC1(x)\n");
	}
	else
	{
		printf("#define BOUND		1\n");
		printf("#define ALIGN(x)	POINTER(x)\n");
		printf("#define TRUNC(x)	POINTER(x)\n");
	}
	printf("\n");
	printf("#define BIT1		0x%lx\n", bit1);
	if (align1 == align2)
	{
		printf("#define BOUND1		BOUND2\n");
		printf("#define ALIGN1(x)	ALIGN2(x)\n");
		printf("#define TRUNC1(x)	TRUNC2(x)\n");
	}
	else
	{
		printf("#define BOUND1		%d\n", align1);
		printf("#define ALIGN1(x)	TRUNC1((x)+%d)\n", align1 - 1);
		printf("#define TRUNC1(x)	POINTER(INTEGER((x)+%d)&0x%lx)\n", align1 - 1, ~(bits0|bits1));
	}
	printf("#define CLRBIT1(x)	POINTER(INTEGER(x)&0x%lx)\n", ~bit1);
	printf("#define SETBIT1(x)	POINTER(INTEGER(x)|0x%lx)\n", bit1);
	printf("#define TSTBIT1(x)	POINTER(INTEGER(x)&0x%lx)\n", bit1);
	printf("\n");
	printf("#define BIT2		0x%lx\n", bit2);
	printf("#define BOUND2		%d\n", align2);
	printf("#define ALIGN2(x)	TRUNC2((x)+%d)\n", align2 - 1);
	printf("#define TRUNC2(x)	POINTER(INTEGER(x)&0x%lx)\n", ~(bits0|bits1|bits2));
	printf("#define CLRBIT2(x)	POINTER(INTEGER(x)&0x%lx)\n", ~bit2);
	printf("#define SETBIT2(x)	POINTER(INTEGER(x)|0x%lx)\n", bit2);
	printf("#define TSTBIT2(x)	POINTER(INTEGER(x)&0x%lx)\n", bit2);
	printf("\n");
	return(0);
}
