/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: getuniv.c /main/3 1995/11/01 17:57:11 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*          Copyright (c) 1994 AT&T Bell Laboratories           *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Software Engineering Research Department           *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                   advsoft@research.att.com                   *
*                 Randy Hackbarth 908-582-5245                 *
*                  Dave Belanger 908-582-7427                  *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#line 1

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif

#line 9
#include "univlib.h"

#include <stak.h>

char*
getuniv __PARAM__((void), ())
#line 15
{
	static char	buf[UNIV_SIZE + 1];

#if _lib_getuniverse
	return(getuniverse(buf) < 0 ? 0 : buf);
#else
#ifndef UNIV_MAX
	char*	u;
	char*	p;

	if (!(u = getenv(univ_env)) || !*u)
	{
		u = _UNIV_DEFAULT;
		if (p = getenv("PATH"))
		{
			int	r = 1;
			char*	d = p;
			int		offset = staktell();

			for (;;)
			{
				switch (*p++)
				{
				case 0:
					break;
				case ':':
					if (!streq(u, "att"))
					{
						if (r = p - d - 1)
						{
							/*
							 * ksh88 convention
							 * att if echo in PATH
							 */

							stakwrite(d, r);
							stakwrite("/echo", 6);
							stakseek(offset);
							if (!access(stakptr(offset), X_OK))
								u = "att";
						}
						d = p;
					}
					r = 1;
					continue;
				case '/':
					if (r)
					{
						r = 0;
						if (strneq(p, "bin:", 4) || strneq(p, "usr/bin:", 8)) break;
					}
					if (strneq(p, "5bin", 4))
					{
						u = "att";
						break;
					}
					if (strneq(p, "bsd", 3))
					{
						u = "ucb";
						break;
					}
					continue;
				default:
					r = 0;
					continue;
				}
				break;
			}
		}
	}
	strncpy(buf, u, UNIV_SIZE - 1);
	buf[UNIV_SIZE - 1] = 0;
	return(buf);
#else
#if defined(ATT_UNIV) || defined(U_GET)
	int	n;

#if defined(ATT_UNIV)
	if ((n = setuniverse(ATT_UNIV)) < 0) return(0);
	setuniverse(n);
#else
	if ((n = universe(U_GET) + 1) <= 0) return(0);
#endif
	if (n >= 1 && n <= UNIV_MAX)
	{
		strncpy(buf, univ_name[n - 1], UNIV_SIZE - 1);
		buf[UNIV_SIZE - 1] = 0;
		return(buf);
	}
	errno = EINVAL;
	return(0);
#endif
#endif
#endif
}
