/*
 * CDE - Common Desktop Environment
 *
 * Copyright (c) 1993-2012, The Open Group. All rights reserved.
 *
 * These libraries and programs are free software; you can
 * redistribute them and/or modify them under the terms of the GNU
 * Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * These libraries and programs are distributed in the hope that
 * they will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with these libraries and programs; if not, write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA 02110-1301 USA
 */
/* $XConsortium: pathtemp.c /main/3 1995/11/01 18:01:18 rswiston $ */
/***************************************************************
*                                                              *
*                      AT&T - PROPRIETARY                      *
*                                                              *
*        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF        *
*                    AT&T BELL LABORATORIES                    *
*         AND IS NOT TO BE DISCLOSED OR USED EXCEPT IN         *
*            ACCORDANCE WITH APPLICABLE AGREEMENTS             *
*                                                              *
*          Copyright (c) 1994 AT&T Bell Laboratories           *
*              Unpublished & Not for Publication               *
*                     All Rights Reserved                      *
*                                                              *
*       The copyright notice above does not evidence any       *
*      actual or intended publication of such source code      *
*                                                              *
*               This software was created by the               *
*           Software Engineering Research Department           *
*                    AT&T Bell Laboratories                    *
*                                                              *
*               For further information contact                *
*                   advsoft@research.att.com                   *
*                 Randy Hackbarth 908-582-5245                 *
*                  Dave Belanger 908-582-7427                  *
*                                                              *
***************************************************************/

/* : : generated by proto : : */

#line 1

#if !defined(__PROTO__)
#if defined(__STDC__) || defined(__cplusplus) || defined(_proto) || defined(c_plusplus)
#if defined(__cplusplus)
#define __MANGLE__	"C"
#else
#define __MANGLE__
#endif
#define __STDARG__
#define __PROTO__(x)	x
#define __OTORP__(x)
#define __PARAM__(n,o)	n
#if !defined(__STDC__) && !defined(__cplusplus)
#if !defined(c_plusplus)
#define const
#endif
#define signed
#define void		int
#define volatile
#define __V_		char
#else
#define __V_		void
#endif
#else
#define __PROTO__(x)	()
#define __OTORP__(x)	x
#define __PARAM__(n,o)	o
#define __MANGLE__
#define __V_		char
#define const
#define signed
#define void		int
#define volatile
#endif
#if defined(__cplusplus) || defined(c_plusplus)
#define __VARARG__	...
#else
#define __VARARG__
#endif
#if defined(__STDARG__)
#define __VA_START__(p,a)	va_start(p,a)
#else
#define __VA_START__(p,a)	va_start(p)
#endif
#endif

#line 24
#include <ast.h>

#define TOTAL	128
#define BASE	14
#define PREFIX	6

#define TMPENV	"TMPDIR"
#define TMP1	"/tmp"
#define TMP2	"/usr/tmp"

#define LOSEED	'a'
#define HISEED	'z'

char*
pathtemp __PARAM__((char* buf, const char* adir, const char* apfx), (buf, adir, apfx)) __OTORP__(char* buf; const char* adir; const char* apfx;)
#line 39
{
	char*	dir = (char*)adir;
	char*		pfx = (char*)apfx;
	char*	p;
	char*	s;
	int		pid;

	static char*	tmpdir;
	static char	seed[] = { LOSEED - 1, LOSEED, LOSEED, 0 };

	if ((!dir || *dir && access(dir, 3)) && !(dir = tmpdir))
	{
		if ((!(dir = getenv(TMPENV)) || !*dir || strlen(dir) >= (TOTAL - BASE - 2) || access(dir, 3)) && access(dir = TMP1, 3) && access(dir = TMP2, 3))
			return(0);
		tmpdir = dir;
	}
	if (!(s = buf) && !(s = newof(0, char, strlen(dir) + BASE, 2))) return(0);
	for (p = s; *p = *dir++; p++);
	if (p > s && *(p - 1) != '/') *p++ = '/';
	if (pfx)
	{
		dir = pfx;
		pfx = p;
		while (*dir && p < pfx + PREFIX) *p++ = *dir++;
	}
	else pfx = p;
	pfx = dir = p + (BASE - (p - pfx) - sizeof(seed) + 1);
	pid = getpid();
	while (--dir >= p)
	{
		*dir = pid % 10 + '0';
		pid /= 10;
	}
	p = pfx;
	dir = seed;
	while (*p++ = *dir++);
	do
	{
		for (p = pfx; *p == HISEED; *p++ = LOSEED);
		if (!*p)
		{
			if (!buf) free(s);
			s = 0;
			break;
		}
		++*p;
	} while (!access(s, 0));
	p = seed;
	dir = pfx;
	while (*p++ = *dir++);
	return(s);
}
